# Check Spawned
execute on vehicle if entity @s[nbt={OnGround:0b, Invulnerable:1b}] run return run scoreboard players set #giantfresh lvlmc.temp 1
execute if score #giantfresh lvlmc.temp matches 1 as @a[distance=..100] at @s run playsound entity.wither.spawn hostile @s ~ ~ ~
execute if score #giantfresh lvlmc.temp matches 1 on vehicle run data modify entity @s Invulnerable set value 0b
execute if score #giantfresh lvlmc.temp matches 1 run scoreboard players set #giantfresh lvlmc.temp 0


# Visuals
execute store result bossbar giant_bossbar value on vehicle run data get entity @s Health
execute on vehicle at @s run bossbar set giant_bossbar players @a[distance=..100]
execute on vehicle at @s run data modify entity @s Fire set value 0s

# Despawn
execute unless predicate lvlmc:time_night on vehicle run tp 0 -1000 0
execute on vehicle at @s unless entity @a[distance=..70, scores={lvlmc.dead=0}] run return run function lvlmc:assets/boss/giant/despawn


# Phase 1
## Melee
scoreboard players remove @s lvlmc.attackdelay 1
execute as @s[scores={lvlmc.attackdelay=..0}] store success score @s lvlmc.temp on target run damage @s[distance=..4] 8 mob_attack by @e[type=giant,sort=nearest,limit=1]
execute store result score @s lvlmc.temp2 run random value 1..2
execute as @s[scores={lvlmc.attackdelay=..0, lvlmc.temp=1, lvlmc.temp2=1}] on target run effect give @s poison 4 1

scoreboard players set @s[scores={lvlmc.attackdelay=..0, lvlmc.temp=1}] lvlmc.attackdelay 20

scoreboard players set @s lvlmc.temp 1
execute on target run scoreboard players set @e[sort=nearest, tag=giant_brain] lvlmc.temp 0
damage @s[scores={lvlmc.temp=1}] 1 minecraft:generic_kill by @a[limit=1, sort=nearest]



## Beam
execute if score #giantbeam lvlmc.attackdelay matches 21.. unless entity @a[distance=15.., gamemode=!creative] run scoreboard players set #giantbeam lvlmc.attackdelay 40
execute if score #giantbeam lvlmc.attackdelay matches 21.. run scoreboard players set #giantbeam lvlmc.raycount 0
scoreboard players remove #giantbeam lvlmc.attackdelay 1
execute if score #giantbeam lvlmc.attackdelay matches 20 on vehicle positioned ^-1.5 ^1 ^4 anchored eyes facing entity @a[sort=nearest,distance=20.., gamemode=!creative] eyes run function lvlmc:assets/boss/giant/attacks/beam_indicate
execute if score #giantbeam lvlmc.attackdelay matches ..0 on vehicle positioned ^-1.5 ^1 ^4 anchored eyes facing entity @e[type=marker, tag=beamtarget, limit=1] eyes run function lvlmc:assets/boss/giant/attacks/beam
execute if score #giantbeam lvlmc.attackdelay matches ..0 run kill @e[type=marker, tag=beamtarget]
execute if score #giantbeam lvlmc.attackdelay matches ..0 run scoreboard players set #giantbeam lvlmc.attackdelay 60 

execute store result score @s lvlmc.temp run bossbar get giant_bossbar value


# Phase 2
execute unless score @s lvlmc.temp < #giantphase2 lvlmc.temp run return fail
execute if score #giantfresh lvlmc.temp matches 0 run tellraw @a[distance=..100] {"translate":"lvlmc.boss.giant.phase2", "color": "red"}
execute if score #giantfresh lvlmc.temp matches 0 as @a[distance=..100] at @s run playsound minecraft:block.end_portal.spawn ambient @s ~ ~ ~ 1 1.6
scoreboard players set #giantfresh lvlmc.temp 2
weather thunder


## Lightning
execute store result score #giantlightning lvlmc.temp run random value 1..100
execute at @e[type=marker, tag=lightning_mark] run particle minecraft:electric_spark ~ ~ ~ .4 .4 .4 0.5 30
execute at @e[type=marker, tag=lightning_mark] run playsound minecraft:entity.allay.ambient_without_item master @a ~ ~ ~ 0.5 2
function lvlmc:assets/boss/giant/attacks/init_earthquakes

execute unless score #giantlightning lvlmc.attackdelay matches ..0 run scoreboard players remove #giantlightning lvlmc.attackdelay 1
execute if score #giantlightning lvlmc.attackdelay matches 0 run execute unless score #giantlightning lvlmc.temp matches 1..30 run scoreboard players set #giantlightning lvlmc.attackdelay -1
execute if score #giantlightning lvlmc.attackdelay matches 0 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.attackdelay matches 0 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.attackdelay matches 0 unless score #difficulty lvlmc.temp matches ..1 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.attackdelay matches 0 unless score #difficulty lvlmc.temp matches ..1 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.attackdelay matches 0 unless score #difficulty lvlmc.temp matches ..2 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.attackdelay matches 0 unless score #difficulty lvlmc.temp matches ..2 run summon marker ~ ~ ~ {Tags:["lightning_mark"]}
execute if score #giantlightning lvlmc.attackdelay matches 0 run spreadplayers ~ ~ 20 30 false @e[type=minecraft:marker, tag=lightning_mark]
execute if score #giantlightning lvlmc.attackdelay matches 0 run scoreboard players set #giantlightning lvlmc.attackdelay -40

execute unless score #giantlightning lvlmc.attackdelay matches 1.. run scoreboard players add #giantlightning lvlmc.attackdelay 1
execute if score #giantlightning lvlmc.attackdelay matches 0 at @e[type=marker, tag=lightning_mark] as @a[distance=..5] run damage @s 40 minecraft:lightning_bolt
execute if score #giantlightning lvlmc.attackdelay matches 0 at @e[type=marker, tag=lightning_mark] run summon lightning_bolt ~ ~-2 ~
execute if score #giantlightning lvlmc.attackdelay matches 0 at @e[type=marker, tag=lightning_mark] run summon marker ~ ~ ~ {Tags:["earthquake_mark"], data:{distance:0}}
execute if score #giantlightning lvlmc.attackdelay matches 0 run kill @e[type=marker, tag=lightning_mark]
execute if score #giantlightning lvlmc.attackdelay matches 0 run scoreboard players set #giantlightning lvlmc.attackdelay 30


## Waves of Zombs
execute if score #giantwaves lvlmc.attackdelay matches 0 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}], Tags:["giant_minion", "spread"], DeathLootTable:"entities/giant_minion"}
execute if score #giantwaves lvlmc.attackdelay matches 0 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}], Tags:["giant_minion", "spread"], DeathLootTable:"entities/giant_minion"}
execute if score #giantwaves lvlmc.attackdelay matches 0 unless score #difficulty lvlmc.temp matches ..1 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}], Tags:["giant_minion", "spread"], DeathLootTable:"entities/giant_minion"}
execute if score #giantwaves lvlmc.attackdelay matches 0 unless score #difficulty lvlmc.temp matches ..1 run summon zombie ~ ~ ~ {CustomName:'"Giant Minion"', Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}], Tags:["giant_minion", "spread"], DeathLootTable:"entities/giant_minion"}
execute if score #giantwaves lvlmc.attackdelay matches 0 unless score #difficulty lvlmc.temp matches ..2 run summon drowned ~ ~ ~ {HandItems:[{id:"minecraft:trident", Count:1b}], CustomName:'"Giant Minion"', Attributes:[{Name:"minecraft:generic.follow_range", Base:1000}, {Name:"minecraft:generic.movement_speed", Base:0.3}], Tags:["giant_minion", "spread"], DeathLootTable:"entities/giant_minion"}
execute if score #giantwaves lvlmc.attackdelay matches 0 run spreadplayers ~ ~ 10 20 false @e[tag=spread]
execute if score #giantwaves lvlmc.attackdelay matches 0 run tag @e[tag=spread] remove spread
execute if score #giantwaves lvlmc.attackdelay matches 0 run scoreboard players set #giantwaves lvlmc.attackdelay 1

execute unless entity @e[tag=giant_minion] run scoreboard players remove #giantwaves lvlmc.attackdelay 1